#lang racket

;;;; 9. cvičenie z predmetu 2-AIN-285 Symbolické programovanie a LISP
;;;;
;;;; Meno a priezvisko:
;;;; Verzia DrRacket: 6.10.1
;;;; Dátum: 7.5.2018
;;;; WWW: http://www.ii.fmph.uniba.sk/cl/view.php/courses/2-AIN-285-lisp/1718ls/?lang=sk 
;;;; Kontakt: Jan.Komara(at)fmph.uniba.sk 
;;;;
;;;; Úvodná poznámka. Toto cvičenie je venované týmto témam:
;;;; - metainterpreter programovacieho jazyka LISP,
;;;; - príprava na semestrálny test.
;;;; Zadanie sa skladá z týchto súborov: 
;;;; - Súbory ex*.rkt obsahujú úlohy, ktoré máte riešiť na tomto cvičení.
;;;; Pozri tiež súbor priprava_na_test.txt
;;;;
;;;; Hodnotenie.
;;;; - Počet bodov za úlohy v tomto súbore: 5-10 (lazy)
;;;; - Počet bodov za prémiove úlohy v tomto súbore: 0
;;;; - Počet bodov za projektové úlohy v tomto súbore: 10 (assignment ... quote)
;;;; Odovzdať do 13.5.2018 (nedeľa) do 12:00.

;; [Lisp]

(require racket/undefined)
(define ... undefined)
;; (define (query f m n) (for/list ([i (in-range m (+ n 1))]) (list i (f i))))

;; Literatúra.
;; [1] Hal Abelson and Jerry Sussman and Julie Sussman.
;;     Structure and Interpretation of Computer Programs.
;;     MIT Press, second edition, 1996. 

;; (define apply-in-underlying-scheme apply)
(require scheme/mpair)

;;; Kapitola. Metainterpreter programovacieho jazyka LISP.

;;; Sekcia. Vyhodnocovanie výrazov v prostredí väzieb.

;;; Podsekcia. Aritmetizácia.

;; Rozlišovacie položky zoznamových konštruktorov.

(define (tagged-list? exp tag)
  (and (pair? exp)
       (equal? (car exp) tag)))

;; Aritmetizácia výrazov (schéma). 

(define (make-<variant> ...) (list '<variant> ...))     ; konštruktor
(define (<variant>? exp) (tagged-list? exp '<variant>)) ; predikát
(define (<variant>-<selector> exp) ...)                 ; selektor(y)
(define (eval-<variant> exp env) ...)                   ; vyhodnocovanie

;;; Podsekcia. Vyhodnocovanie výrazov v prostredí väzieb.

;; Pokyny. Pozri tiež predchadzajúce cvičenie.

;; Operácia my-eval(exp,env) vyhodnotí výraz exp v prostredí väzieb env.

(define (my-eval exp env)
  (cond [(<variant>? exp) (eval-<variant> exp env)]
        [else (error "Unknown expression type -- EVAL" exp)]))

;;; Podsekcia. Operácie nad prostredím väzieb.

;; Základné operácie.

(define the-empty-environment '())
(define (empty-environment? env) (null? env))
(define (enclosing-environment env) (mcdr env))
(define (first-frame env) (mcar env))
(define the-empty-frame '())
(define (binding-value binding) (mcdr binding))

;; Modifikácia prostredia väzieb.

(define (set-first-frame! env frame) (set-mcar! env frame))
(define (set-binding-value! binding val) (set-mcdr! binding val))

;; Rozšírenie prostredia väzieb.

(define (make-environment frame env)
  (mcons frame env))

(define (add-to-frame-let binding frame)
  (mcons (mcons (car binding) (cadr binding)) frame))

(define (add-to-frame-apply var val frame)
  (mcons (mcons var val) frame))

(define (extend-environment-let bindings env)
  (define (loop bindings frame)
    (if (null? bindings)
        (make-environment frame env)
        (loop (cdr bindings) (add-to-frame-let (car bindings) frame))))
  (loop bindings the-empty-frame))

(define (extend-environment-apply vars vals env)
  (define (loop vars vals frame)
    (if (and (null? vars) (null? vals))
        (make-environment frame env)
        (loop (cdr vars) (cdr vals) (add-to-frame-apply (car vars) (car vals) frame))))
  (loop vars vals the-empty-frame))

;; Globálne prostredie väzieb.

(define (make-primitive-procedure proc)
  (list (string->symbol "primitive procedure") proc))

(define frame-of-primitive-procedures
  (mlist
   (mcons 'zero? (make-primitive-procedure zero?))
   (mcons '+ (make-primitive-procedure +))
   (mcons '- (make-primitive-procedure -))
   (mcons '* (make-primitive-procedure *))
   (mcons 'quotient (make-primitive-procedure quotient))
   (mcons 'remainder (make-primitive-procedure remainder))
   (mcons '= (make-primitive-procedure =))
   (mcons '<= (make-primitive-procedure <=))
   (mcons '< (make-primitive-procedure <))
   (mcons '>= (make-primitive-procedure >=))
   (mcons '> (make-primitive-procedure >))
   (mcons '... (make-primitive-procedure undefined))
   (mcons 'null (make-primitive-procedure null))
   (mcons 'null? (make-primitive-procedure null?))
   (mcons 'cons (make-primitive-procedure cons))
   (mcons 'pair? (make-primitive-procedure pair?))
   (mcons 'car (make-primitive-procedure car))
   (mcons 'cdr (make-primitive-procedure cdr))
   (mcons '#t (make-primitive-procedure #t))
   (mcons '#f (make-primitive-procedure #f))
   ))

(define the-global-environment
  (make-environment frame-of-primitive-procedures the-empty-environment))

;;; Podsekcia. Samo vyhodnocujúce sa výrazy.

;; Pokyny. Pozri predchadzajúce cvičenie.

;;; Podsekcia. Premenné.

;; Pokyny. Pozri predchadzajúce cvičenie.

;;; Podsekcia. Špeciálna forma if (podmienkové výrazy).

;; Pokyny. Pozri tiež predchadzajúce cvičenie.

(define (eval-if exp env) ...)

;;; Podsekcia. Špeciálna forma let (priradenie do lokálnej premennej).

;; Pokyny. Pozri predchadzajúce cvičenie.

;;; Podsekcia. Špeciálna forma set! (priradenie).

;; Konštruktor.

(define (make-assignment variable value) (list 'set! variable value))

;; Predikát.

(define (assignment? exp) ...)

;; Selektor(y).

(define (assignment-variable exp) ...)
(define (assignment-value exp) ...)

;; Vyhodnocovanie.

(define (set-variable-value! var val env) ...)
(define (eval-assignment exp env) ...)

;; Testovanie.

;; (define assignment-environment (extend-environment-let '([x 1]) (extend-environment-let '([y 2]) the-global-environment)))
;; assignment-environment
;; (begin (my-eval '(set! x 11) assignment-environment) assignment-environment)
;; (begin (my-eval '(set! y 22) assignment-environment) assignment-environment)

;;; Podsekcia. Špeciálna forma begin (postupnosť výrazov).

;; Konštruktor.

(define (make-begin seq) (list* 'begin seq))
;; (define (make-begin seq) (cons 'begin seq)) ; alternatívna definícia

;; Predikát(y).

(define (begin? exp) ...)
(define (last-exp? seq) ...)

;; Selektor(y).

(define (begin-actions exp) ...)
(define (first-exp seq) ...)
(define (rest-exps seq) ...)

;; Vyhodnocovanie.

(define (eval-sequence exps env) ...)
(define (eval-begin exp env) ...)

;; Testovanie.

;; (my-eval '(begin 1) the-global-environment)
;; (my-eval '(begin 2 1) the-global-environment)
;; (my-eval '(begin 3 2 1) the-global-environment)

;;; Podsekcia. Špeciálna forma cond (podmienkové výrazy).

;; Konštruktor.

(define (make-cond clauses) (list* 'cond clauses))
;; (define (make-cond clauses) (cons 'cond clauses)) ; alternatívna definícia

;; Predikát.

(define (cond? exp) ...)

;; Selektor(y).

;; Vyhodnocovanie.

(define (eval-cond exp env) ...)

;; Testovanie.

;; (my-eval '(cond [#t 1]) the-global-environment)
;; (my-eval '(cond [#f 2] [#t 1]) the-global-environment)
;; (my-eval '(cond [#f 3] [#f 2] [#t 1]) the-global-environment)

;;; Podsekcia. Špeciálna forma and (konjunkcia).

;; Konštruktor.

(define (make-and predicates) (list* 'and predicates))
;; (define (make-and predicates) (cons 'and predicates)) ; alternatívna definícia

;; Predikát.

(define (and? exp) ...)

;; Selektor(y).

;; Vyhodnocovanie.

(define (eval-and exp env) ...)

;; Testovanie.

;; (my-eval '(and) the-global-environment)
;; (my-eval '(and #t) the-global-environment)
;; (my-eval '(and #t #t) the-global-environment)
;; (not (my-eval '(and #f) the-global-environment))
;; (not (my-eval '(and #t #f) the-global-environment))

;;; Podsekcia. Špeciálna forma or (disjunkcia).

;; Konštruktor.

(define (make-or predicates) (list* 'or predicates))
;; (define (make-or predicates) (cons 'or predicates)) ; alternatívna definícia

;; Predikát.

(define (or? exp) ...)

;; Selektor(y).

;; Vyhodnocovanie.

(define (eval-or exp env) ...)

;; Testovanie.

;; (not (my-eval '(or) the-global-environment))
;; (my-eval '(or #t) the-global-environment)
;; (my-eval '(or #f #t) the-global-environment)
;; (not (my-eval '(or #f) the-global-environment))
;; (not (my-eval '(or #t #f) the-global-environment))

;;; Podsekcia. Špeciálna forma quote (výrazy s apostrofom).

;; Konštruktor.

(define (make-quoted text) (list 'quote text))

;; Predikát.

(define (quoted? exp) ...)

;; Selektor(y).

(define (text-of-quotation exp) (cadr exp))

;; Vyhodnocovanie.

(define (eval-quoted exp env) ...)

;; Testovanie.

;; (my-eval '(quote a) the-global-environment)

;;; Podsekcia. Špeciálna forma define (definície).

;; Pokyny. Pozri predchadzajúce cvičenie.

;;; Podsekcia. Špeciálna forma lambda (operátor abstrakcie).

;; Pokyny. Pozri predchadzajúce cvičenie.

;;; Podsekcia. Aplikatívne výrazy.

;; Pokyny. Pozri tiež predchadzajúce cvičenie.

(define (eval-application exp env) ...)

;;; Podsekcia. Programy.

;; Pokyny. Pozri tiež predchadzajúce cvičenie.

(define (my-apply proc args) ...)

;;; Podsekcia. Prostredie pre lenivé vyhodnocovanie.

;; Operácie na modifikovateľných dvojiciach.

(define (mcadr x) ...)
(define (mcaddr x) ...)

;; Rozlišovacie položky zoznamových konštruktorov.

(define (tagged-mlist? exp tag)
  (and (mpair? exp)
       (equal? (mcar exp) tag)))

;; Operácia actual-value(exp,env) vyhodnotí výraz exp v prostredí väzieb env.

(define (actual-value exp env) ...)

;; Konštruktor(y).

(define (delay-it exp env) (mlist 'thunk exp env)) ;; alternatívny názov make-thunk
(define (delay-it-memo exp env) (mlist 'memo-thunk exp env)) ;; alternatívny názov make-memo-thunk

(define (make-evaluated-thunk obj) (mlist 'evaluated-thunk obj))

;; Predikát(y).

(define (thunk? obj) ...)
(define (memo-thunk? obj) ...)
(define (evaluated-thunk? obj) ...)

;; Selektor(y).

(define (thunk-exp thunk) ...)
(define (thunk-env thunk) ...)
(define (thunk-value evaluated-thunk) ...)

;; Vyhodnocovanie.

(define (force-it obj) ...)

;; Testovanie.

;; (my-eval '(define (f (x lazy)) x) the-global-environment)
;; the-global-environment
;; (my-eval '(f 0) the-global-environment)
;; (actual-value '(f 0) the-global-environment)

;; (my-eval '(define (f (x lazy-memo)) x) the-global-environment)
;; the-global-environment
;; (my-eval '(f 0) the-global-environment)
;; (actual-value '(f 0) the-global-environment)

;; (my-eval '(define (infinite-loop x) (foo x)) the-global-environment)
;; (my-eval '(define (fst-proj x (y lazy)) x) the-global-environment)
;; the-global-environment
;; (my-eval '(fst-proj 1 (infinite-loop 2)) the-global-environment)
;; (my-eval '(+ (fst-proj 1 (infinite-loop 2)) 3) the-global-environment)

;; (my-eval '(define (infinite-loop x) (foo x)) the-global-environment)
;; (my-eval '(define (fst-proj (x lazy) (y lazy)) x) the-global-environment)
;; the-global-environment
;; (my-eval '(fst-proj 1 (infinite-loop 2)) the-global-environment)
;; (actual-value '(fst-proj 1 (infinite-loop 2) 3) the-global-environment)
;; (my-eval '(+ (fst-proj 1 (infinite-loop 2)) 3) the-global-environment)
;; (actual-value '(+ (fst-proj 1 (infinite-loop 2)) 3) the-global-environment)
